/* bufr.h - I/O buffer interface */

#ifndef BUFR_H
#define BUFR_H

  /* medium size temporary memory storage: */
byte *Mcpy(byte *buf,int len); /* make copy of buf in new mem location */
void Mfreeall(void);           /* free all things Mcpy'd */

  /* I/O buffer interface */
extern position infosz,real_infosz; /* these should all be read only */
extern char file_name[MAXSTRLEN+1];
extern int bf_loaded;
extern int bf_writeable; /* 0 (ro)   1- this file only   2- all files */

void bf_debug(void);                        /* print debug info */
void bf_init(char *name,int loadfile);      /* initialize buffer */
void bf_write_back_all(void);               /* write back all modified */
void bf_set_writeable(int newval);          /* set writable flag */
void bf_modifiing(position off);            /* indicate modifiing a chunk */
byte *bf_loadchunk(position off,int *size); /* return pointer to off */

   /* return point to stuff ending at off: */
byte *bf_loadchunk_back(position off,int *size);
int bf_changesize(position newsz);          /* change file size */
byte *bf_16(position off,int *size);        /* get 16 byte chunk */

   /* get arbitrary size chunk: */
void *bf_buffer(position off,int *size,void *buf,int rsize);
byte bf_byte(position off);                 /* get byte */
word bf_word(position off);                 /* get word */
dword bf_dword(position off);               /* get dword */
int bf_memcmp(position off,byte *s2,position len); /* like memcmp() */

#endif /*BUFR_H*/
