/* general.h - general header file */

#ifndef GENERAL_H
#define GENERAL_H

/* #define TESTING_BUF /* */

#define INC_UNASM /* disassembler */
#define INC_DOSDIR /* dos directory interpreter */
#define INC_DOSDIR_HDR /* print header for directories (when start changed) */
/* #define INC_DOSDIR_HDR_ALL /* header for directories (always) */
/* #define INC_LOADCORE /* doesn't work right now */

#define ASCII_CLEAN /* prints ascii 127-255 as '.' */

/* #define BAD_COMPILER /* indicates to perform certain work-arounds */

#ifdef BAD_COMPILER
# define NOT(x) ((-(x))-1) /* compiler bug workaround */
#else /* ! BAD_COMPILER */
# define NOT(x) (~(x))
#endif /* BAD_COMPILER */

#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <memory.h>

#ifdef INC_LOADCORE
#include <sys/types.h>
#include <sys/signal.h>
#include <sys/dir.h>
#include <sys/param.h>
#include <sys/reg.h>
#include <sys/user.h>
#endif /*INC_LOADCORE*/

typedef unsigned int position;

#define MAXSTRLEN   255

void error(char *str);
void fatalerror(char *str);

extern unsigned char ascii_map[0x100];

#include "lowtype.h"
#include "bufr.h"

#endif /*GENERAL_H*/
